diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc ns-3.34/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc
--- ns-3.33/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/model/ipv4-nix-vector-routing.cc	2021-07-14 10:31:07.000000000 -0700
@@ -128,7 +128,7 @@
 }
 
 Ptr<NixVector>
-Ipv4NixVectorRouting::GetNixVector (Ptr<Node> source, Ipv4Address dest, Ptr<NetDevice> oif)
+Ipv4NixVectorRouting::GetNixVector (Ptr<Node> source, Ipv4Address dest, Ptr<NetDevice> oif) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -173,7 +173,7 @@
 }
 
 Ptr<NixVector>
-Ipv4NixVectorRouting::GetNixVectorInCache (Ipv4Address address)
+Ipv4NixVectorRouting::GetNixVectorInCache (Ipv4Address address) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -236,7 +236,7 @@
 }
 
 bool
-Ipv4NixVectorRouting::BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector)
+Ipv4NixVectorRouting::BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -309,7 +309,7 @@
 }
 
 void
-Ipv4NixVectorRouting::GetAdjacentNetDevices (Ptr<NetDevice> netDevice, Ptr<Channel> channel, NetDeviceContainer & netDeviceContainer)
+Ipv4NixVectorRouting::GetAdjacentNetDevices (Ptr<NetDevice> netDevice, Ptr<Channel> channel, NetDeviceContainer & netDeviceContainer) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -349,7 +349,7 @@
 }
 
 void
-Ipv4NixVectorRouting::BuildIpv4AddressToNodeMap (void)
+Ipv4NixVectorRouting::BuildIpv4AddressToNodeMap (void) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -372,14 +372,18 @@
                   int32_t interfaceIndex = (ipv4)->GetInterfaceForDevice (node->GetDevice (deviceId));
                   if (interfaceIndex != -1)
                     {
-                      Ipv4InterfaceAddress ifAddr = ipv4->GetAddress (interfaceIndex, 0);
-                      Ipv4Address addr = ifAddr.GetLocal ();
-
-                      NS_ABORT_MSG_IF (g_ipv4AddressToNodeMap.count (addr),
-                                       "Duplicate IPv4 address (" << addr << ") found during NIX Vector map construction for node " << node->GetId ());
-
-                      NS_LOG_LOGIC ("Adding IPv4 address " << addr << " for node " << node->GetId () << " to NIX Vector IPv4 address to node map");
-                      g_ipv4AddressToNodeMap[addr] = node;
+                      uint32_t numberOfAddresses = ipv4->GetNAddresses (interfaceIndex);
+                      for (uint32_t addressIndex = 0; addressIndex < numberOfAddresses; addressIndex++)
+                        {
+                          Ipv4InterfaceAddress ifAddr = ipv4->GetAddress (interfaceIndex, addressIndex);
+                          Ipv4Address addr = ifAddr.GetLocal ();
+
+                          NS_ABORT_MSG_IF (g_ipv4AddressToNodeMap.count (addr),
+                                          "Duplicate IPv4 address (" << addr << ") found during NIX Vector map construction for node " << node->GetId ());
+
+                          NS_LOG_LOGIC ("Adding IPv4 address " << addr << " for node " << node->GetId () << " to NIX Vector IPv4 address to node map");
+                          g_ipv4AddressToNodeMap[addr] = node;
+                        }
                     }
                 }
             }
@@ -388,7 +392,7 @@
 }
 
 Ptr<Node>
-Ipv4NixVectorRouting::GetNodeByIp (Ipv4Address dest)
+Ipv4NixVectorRouting::GetNodeByIp (Ipv4Address dest) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -416,9 +420,9 @@
 }
 
 uint32_t
-Ipv4NixVectorRouting::FindTotalNeighbors (void)
+Ipv4NixVectorRouting::FindTotalNeighbors (Ptr<Node> node) const
 {
-  uint32_t numberOfDevices = m_node->GetNDevices ();
+  uint32_t numberOfDevices = node->GetNDevices ();
   uint32_t totalNeighbors = 0;
 
   // scan through the net devices on the parent node
@@ -428,7 +432,7 @@
       // Get a net device from the node
       // as well as the channel, and figure
       // out the adjacent net devices
-      Ptr<NetDevice> localNetDevice = m_node->GetDevice (i);
+      Ptr<NetDevice> localNetDevice = node->GetDevice (i);
       Ptr<Channel> channel = localNetDevice->GetChannel ();
       if (channel == 0)
         {
@@ -487,9 +491,9 @@
 }
 
 uint32_t
-Ipv4NixVectorRouting::FindNetDeviceForNixIndex (uint32_t nodeIndex, Ipv4Address & gatewayIp)
+Ipv4NixVectorRouting::FindNetDeviceForNixIndex (Ptr<Node> node, uint32_t nodeIndex, Ipv4Address & gatewayIp) const
 {
-  uint32_t numberOfDevices = m_node->GetNDevices ();
+  uint32_t numberOfDevices = node->GetNDevices ();
   uint32_t index = 0;
   uint32_t totalNeighbors = 0;
 
@@ -500,7 +504,7 @@
       // Get a net device from the node
       // as well as the channel, and figure
       // out the adjacent net devices
-      Ptr<NetDevice> localNetDevice = m_node->GetDevice (i);
+      Ptr<NetDevice> localNetDevice = node->GetDevice (i);
       Ptr<Channel> channel = localNetDevice->GetChannel ();
       if (channel == 0)
         {
@@ -565,14 +569,13 @@
 
       // create a new nix vector to be used, 
       // we want to keep the cached version clean
-      nixVectorForPacket = Create<NixVector> ();
       nixVectorForPacket = nixVectorInCache->Copy (); 
 
       // Get the interface number that we go out of, by extracting
       // from the nix-vector
       if (m_totalNeighbors == 0)
         {
-          m_totalNeighbors = FindTotalNeighbors ();
+          m_totalNeighbors = FindTotalNeighbors (m_node);
         }
 
       // Get the interface number that we go out of, by extracting
@@ -598,7 +601,7 @@
 
           NS_LOG_LOGIC ("Ipv4Route not in cache, build: ");
           Ipv4Address gatewayIp;
-          uint32_t index = FindNetDeviceForNixIndex (nodeIndex, gatewayIp);
+          uint32_t index = FindNetDeviceForNixIndex (m_node, nodeIndex, gatewayIp);
           int32_t interfaceIndex = 0;
 
           if (!oif)
@@ -612,11 +615,11 @@
 
           NS_ASSERT_MSG (interfaceIndex != -1, "Interface index not found for device");
 
-          Ipv4InterfaceAddress ifAddr = m_ipv4->GetAddress (interfaceIndex, 0);
+          Ipv4Address sourceIPAddr = m_ipv4->SourceAddressSelection (interfaceIndex, header.GetDestination ());
 
           // start filling in the Ipv4Route info
           rtentry = Create<Ipv4Route> ();
-          rtentry->SetSource (ifAddr.GetLocal ());
+          rtentry->SetSource (sourceIPAddr);
 
           rtentry->SetGateway (gatewayIp);
           rtentry->SetDestination (header.GetDestination ());
@@ -701,7 +704,7 @@
   // from the nix-vector
   if (m_totalNeighbors == 0)
     {
-      m_totalNeighbors = FindTotalNeighbors ();
+      m_totalNeighbors = FindTotalNeighbors (m_node);
     }
   uint32_t numberOfBits = nixVector->BitCount (m_totalNeighbors);
   uint32_t nodeIndex = nixVector->ExtractNeighborIndex (numberOfBits);
@@ -712,7 +715,7 @@
     {
       NS_LOG_LOGIC ("Ipv4Route not in cache, build: ");
       Ipv4Address gatewayIp;
-      uint32_t index = FindNetDeviceForNixIndex (nodeIndex, gatewayIp);
+      uint32_t index = FindNetDeviceForNixIndex (m_node, nodeIndex, gatewayIp);
       uint32_t interfaceIndex = (m_ipv4)->GetInterfaceForDevice (m_node->GetDevice (index));
       Ipv4InterfaceAddress ifAddr = m_ipv4->GetAddress (interfaceIndex, 0);
 
@@ -747,10 +750,15 @@
   CheckCacheStateAndFlush ();
 
   std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
 
   *os << "Node: " << m_ipv4->GetObject<Node> ()->GetId ()
       << ", Time: " << Now().As (unit)
-      << ", Local time: " << GetObject<Node> ()->GetLocalTime ().As (unit)
+      << ", Local time: " << m_ipv4->GetObject<Node> ()->GetLocalTime ().As (unit)
       << ", Nix Routing" << std::endl;
 
   *os << "NixCache:" << std::endl;
@@ -761,7 +769,7 @@
         {
           std::ostringstream dest;
           dest << it->first;
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << dest.str ();
+          *os << std::setw (16) << dest.str ();
           *os << *(it->second) << std::endl;
         }
     }
@@ -773,11 +781,11 @@
         {
           std::ostringstream dest, gw, src;
           dest << it->second->GetDestination ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << dest.str ();
+          *os << std::setw (16) << dest.str ();
           gw << it->second->GetGateway ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << gw.str ();
+          *os << std::setw (16) << gw.str ();
           src << it->second->GetSource ();
-          *os << std::setiosflags (std::ios::left) << std::setw (16) << src.str ();
+          *os << std::setw (16) << src.str ();
           *os << "  ";
           if (Names::FindName (it->second->GetOutputDevice ()) != "")
             {
@@ -791,6 +799,8 @@
         }
     }
   *os << std::endl;
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
 }
 
 // virtual functions from Ipv4RoutingProtocol 
@@ -818,7 +828,7 @@
 bool
 Ipv4NixVectorRouting::BFS (uint32_t numberOfNodes, Ptr<Node> source, 
                            Ptr<Node> dest, std::vector< Ptr<Node> > & parentVector,
-                           Ptr<NetDevice> oif)
+                           Ptr<NetDevice> oif) const
 {
   NS_LOG_FUNCTION_NOARGS ();
 
@@ -961,6 +971,126 @@
   return false;
 }
 
+void
+Ipv4NixVectorRouting::PrintRoutingPath (Ptr<Node> source, Ipv4Address dest,
+                                        Ptr<OutputStreamWrapper> stream, Time::Unit unit) const
+{
+  NS_LOG_FUNCTION (this << source << dest);
+  Ptr<NixVector> nixVectorInCache;
+  Ptr<NixVector> nixVector;
+  Ptr<Ipv4Route> rtentry;
+
+  CheckCacheStateAndFlush ();
+
+  Ptr<Node> destNode = GetNodeByIp (dest);
+  if (destNode == 0)
+    {
+      NS_LOG_ERROR ("No routing path exists");
+      return;
+    }
+
+  std::ostream* os = stream->GetStream ();
+  // Copy the current ostream state
+  std::ios oldState (nullptr);
+  oldState.copyfmt (*os);
+
+  *os << std::resetiosflags (std::ios::adjustfield) << std::setiosflags (std::ios::left);
+  *os << "Time: " << Now().As (unit)
+      << ", Nix Routing" << std::endl;
+  *os << "Route Path: ";
+  *os << "(Node " << source->GetId () << " to Node " << destNode->GetId () << ", ";
+  *os << "Nix Vector: ";
+
+  nixVectorInCache = GetNixVectorInCache (dest);
+
+  // not in cache
+  if (!nixVectorInCache)
+    {
+      NS_LOG_LOGIC ("Nix-vector not in cache, build: ");
+      // Build the nix-vector, given the source node and the
+      // dest IP address
+      nixVectorInCache = GetNixVector (source, dest, nullptr);
+    }
+
+  if (nixVectorInCache || (!nixVectorInCache && source == destNode))
+    {
+      Ptr<Node> curr = source;
+      uint32_t totalNeighbors = 0;
+
+      if (nixVectorInCache)
+        {
+          // cache it
+          m_nixCache.insert (NixMap_t::value_type (dest, nixVectorInCache));
+          // Make a NixVector copy to work with. This is because
+          // we don't want to extract the bits from nixVectorInCache
+          // which is stored in the m_nixCache.
+          nixVector = nixVectorInCache->Copy ();
+
+          *os << *nixVector;
+        }
+      *os << ")" << std::endl;
+
+      if (source == destNode)
+        {
+          std::ostringstream src, dst;
+          src << dest << " (Node " << destNode->GetId () << ")";
+          *os << std::setw (20) << src.str ();
+          dst << "---->   " << dest << " (Node " << destNode->GetId () << ")";
+          *os << dst.str () << std::endl;
+        }
+
+      while (curr != destNode)
+        {
+          totalNeighbors = FindTotalNeighbors (curr);
+          // Get the number of bits required
+          // to represent all the neighbors
+          uint32_t numberOfBits = nixVector->BitCount (totalNeighbors);
+          // Get the nixIndex
+          uint32_t nixIndex = nixVector->ExtractNeighborIndex (numberOfBits);
+          // gatewayIP is the IP of next
+          // node on channel found from nixIndex
+          Ipv4Address gatewayIp;
+          // Get the Net Device index from the nixIndex
+          uint32_t NetDeviceIndex = FindNetDeviceForNixIndex (curr, nixIndex, gatewayIp);
+          // Get the interfaceIndex with the help of NetDeviceIndex.
+          // It will be used to get the IP address on interfaceIndex
+          // interface of 'curr' node.
+          Ptr<Ipv4> ipv4 = curr->GetObject<Ipv4> ();
+          Ptr<NetDevice> outDevice = curr->GetDevice (NetDeviceIndex);
+          uint32_t interfaceIndex = ipv4->GetInterfaceForDevice (outDevice);
+          Ipv4Address sourceIPAddr;
+          if (curr == source)
+            {
+              sourceIPAddr = ipv4->SourceAddressSelection (interfaceIndex, dest);
+            }
+          else
+            {
+              // We use the first address because it's indifferent which one
+              // we use to identify intermediate routers
+              sourceIPAddr = ipv4->GetAddress (interfaceIndex, 0).GetLocal ();
+            }
+
+          std::ostringstream currNode, nextNode;
+          currNode << sourceIPAddr << " (Node " << curr->GetId () << ")";
+          *os << std::setw (20) << currNode.str ();
+          // Replace curr with the next node
+          curr = GetNodeByIp (gatewayIp);
+          nextNode << "---->   " << ((curr == destNode) ? dest : gatewayIp) << " (Node " << curr->GetId () << ")";
+          *os << nextNode.str () << std::endl;
+        }
+        *os << std::endl;
+    }
+  else
+    {
+      *os << ")" << std::endl;
+      // No Route exists
+      *os << "There does not exist a path from Node " << source->GetId ()
+          << " to Node " << destNode->GetId () << "." << std::endl;
+    }
+  // Restore the previous ostream state
+  (*os).copyfmt (oldState);
+}
+
 void 
 Ipv4NixVectorRouting::CheckCacheStateAndFlush (void) const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/nix-vector-routing/model/ipv4-nix-vector-routing.h ns-3.34/src/nix-vector-routing/model/ipv4-nix-vector-routing.h
--- ns-3.33/src/nix-vector-routing/model/ipv4-nix-vector-routing.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/nix-vector-routing/model/ipv4-nix-vector-routing.h	2021-07-14 10:31:07.000000000 -0700
@@ -89,6 +89,16 @@
    */
   void FlushGlobalNixRoutingCache (void) const;
 
+  /**
+   * @brief Print the Routing Path according to Nix Routing
+   * \param source Source node
+   * \param dest Destination node address
+   * \param stream The ostream the Routing path is printed to
+   * \param unit the time unit to be used in the report
+   */
+  void PrintRoutingPath (Ptr<Node> source, Ipv4Address dest, Ptr<OutputStreamWrapper> stream, Time::Unit unit) const;
+
+
 private:
 
   /**
@@ -120,14 +130,14 @@
    * \param oif Preferred output interface
    * \returns The NixVector to be used in routing.
    */
-  Ptr<NixVector> GetNixVector (Ptr<Node> source, Ipv4Address dest, Ptr<NetDevice> oif);
+  Ptr<NixVector> GetNixVector (Ptr<Node> source, Ipv4Address dest, Ptr<NetDevice> oif) const;
 
   /**
    * Checks the cache based on dest IP for the nix-vector
    * \param address Address to check
    * \returns The NixVector to be used in routing.
    */
-  Ptr<NixVector> GetNixVectorInCache (Ipv4Address address);
+  Ptr<NixVector> GetNixVectorInCache (Ipv4Address address) const;
 
   /**
    * Checks the cache based on dest IP for the Ipv4Route
@@ -143,7 +153,7 @@
    * \param [in] channel the channel to check
    * \param [out] netDeviceContainer the NetDeviceContainer of the NetDevices in the channel.
    */
-  void GetAdjacentNetDevices (Ptr<NetDevice> netDevice, Ptr<Channel> channel, NetDeviceContainer & netDeviceContainer);
+  void GetAdjacentNetDevices (Ptr<NetDevice> netDevice, Ptr<Channel> channel, NetDeviceContainer & netDeviceContainer) const;
 
   /**
    * Iterates through the node list and finds the one
@@ -151,7 +161,7 @@
    * \param dest destination node IP
    * \return The node with the specified IP.
    */
-  Ptr<Node> GetNodeByIp (Ipv4Address dest);
+  Ptr<Node> GetNodeByIp (Ipv4Address dest) const;
 
   /**
    * Recurses the parent vector, created by BFS and actually builds the nixvector
@@ -161,7 +171,7 @@
    * \param [out] nixVector the NixVector to be used for routing
    * \returns true on success, false otherwise.
    */
-  bool BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector);
+  bool BuildNixVector (const std::vector< Ptr<Node> > & parentVector, uint32_t source, uint32_t dest, Ptr<NixVector> nixVector) const;
 
   /**
    * Special variation of BuildNixVector for when a node is sending to itself
@@ -171,11 +181,13 @@
   bool BuildNixVectorLocal (Ptr<NixVector> nixVector);
 
   /**
-   * Simple iterates through the nodes net-devices and determines
-   * how many neighbors it has
-   * \returns the number of neighbors.
+   * Simply iterates through the nodes net-devices and determines
+   * how many neighbors the node has.
+   * \param [in] node node pointer
+   * \returns the number of neighbors of m_node.
    */
-  uint32_t FindTotalNeighbors (void);
+  uint32_t FindTotalNeighbors (Ptr<Node> node) const;
+
 
   /**
    * Determine if the NetDevice is bridged
@@ -188,11 +200,12 @@
   /**
    * Nix index is with respect to the neighbors.  The net-device index must be
    * derived from this
+   * \param [in] node the current node under consideration
    * \param [in] nodeIndex Nix Node index
    * \param [out] gatewayIp IP address of the gateway
    * \returns the index of the NetDevice in the node.
    */
-  uint32_t FindNetDeviceForNixIndex (uint32_t nodeIndex, Ipv4Address & gatewayIp);
+  uint32_t FindNetDeviceForNixIndex (Ptr<Node> node, uint32_t nodeIndex, Ipv4Address & gatewayIp) const;
 
   /**
    * \brief Breadth first search algorithm.
@@ -207,7 +220,7 @@
             Ptr<Node> source,
             Ptr<Node> dest,
             std::vector< Ptr<Node> > & parentVector,
-            Ptr<NetDevice> oif);
+            Ptr<NetDevice> oif) const;
 
   void DoDispose (void);
 
@@ -231,7 +244,7 @@
   /**
    * Build map from IPv4 Address to Node for faster lookup.
    */
-  void BuildIpv4AddressToNodeMap (void);
+  void BuildIpv4AddressToNodeMap (void) const;
 
   /**
    * Flag to mark when caches are dirty and need to be flushed.  
@@ -253,22 +266,6 @@
 
 
   /**
-   * \brief Hashing for the ipv4Address class
-   */
-  struct Ipv4AddressHash
-  {
-    /**
-     * \brief operator ()
-     * \param address the IPv4 address to hash
-     * \return the hash of the address
-     */
-    size_t operator() (const Ipv4Address &address) const
-    {
-      return std::hash<uint32_t>()(address.Get ());
-    }
-  };
-
-  /**
    * Mapping of IPv4 address to ns-3 node.
    *
    * Used to avoid linear searching of nodes/devices to find a node in
@@ -276,7 +273,7 @@
    * are unique so mapping can be done without duplication.
    **/
   typedef std::unordered_map<Ipv4Address, ns3::Ptr<ns3::Node>, Ipv4AddressHash > Ipv4AddressToNodeMap;
-  static Ipv4AddressToNodeMap g_ipv4AddressToNodeMap;
+  static Ipv4AddressToNodeMap g_ipv4AddressToNodeMap; //!< Address to node map.
 };
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/olsr/bindings/modulegen__gcc_ILP32.py ns-3.34/src/olsr/bindings/modulegen__gcc_ILP32.py
--- ns-3.33/src/olsr/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/olsr/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
@@ -113,6 +113,8 @@
     module.add_class('Ipv4Address', import_from_module='ns.network')
     ## ipv4-address.h (module 'network'): ns3::Ipv4Address [class]
     root_module['ns3::Ipv4Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash [class]
+    module.add_class('Ipv4AddressHash', import_from_module='ns.network')
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress [class]
     module.add_class('Ipv4InterfaceAddress', import_from_module='ns.internet')
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e [enumeration]
@@ -125,6 +127,8 @@
     module.add_class('Ipv6Address', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Address [class]
     root_module['ns3::Ipv6Address'].implicitly_converts_to(root_module['ns3::Address'])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash [class]
+    module.add_class('Ipv6AddressHash', import_from_module='ns.network')
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix [class]
     module.add_class('Ipv6Prefix', import_from_module='ns.network')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -683,10 +687,12 @@
     register_Ns3IntToType__5_methods(root_module, root_module['ns3::IntToType< 5 >'])
     register_Ns3IntToType__6_methods(root_module, root_module['ns3::IntToType< 6 >'])
     register_Ns3Ipv4Address_methods(root_module, root_module['ns3::Ipv4Address'])
+    register_Ns3Ipv4AddressHash_methods(root_module, root_module['ns3::Ipv4AddressHash'])
     register_Ns3Ipv4InterfaceAddress_methods(root_module, root_module['ns3::Ipv4InterfaceAddress'])
     register_Ns3Ipv4Mask_methods(root_module, root_module['ns3::Ipv4Mask'])
     register_Ns3Ipv4RoutingHelper_methods(root_module, root_module['ns3::Ipv4RoutingHelper'])
     register_Ns3Ipv6Address_methods(root_module, root_module['ns3::Ipv6Address'])
+    register_Ns3Ipv6AddressHash_methods(root_module, root_module['ns3::Ipv6AddressHash'])
     register_Ns3Ipv6Prefix_methods(root_module, root_module['ns3::Ipv6Prefix'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3Mac48Address_methods(root_module, root_module['ns3::Mac48Address'])
@@ -1789,6 +1795,18 @@
                    [param('char const *', 'address')])
     return
 
+def register_Ns3Ipv4AddressHash_methods(root_module, cls):
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv4-address.h (module 'network'): ns3::Ipv4AddressHash::Ipv4AddressHash(ns3::Ipv4AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv4AddressHash const &', 'arg0')])
+    ## ipv4-address.h (module 'network'): size_t ns3::Ipv4AddressHash::operator()(ns3::Ipv4Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv4Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv4InterfaceAddress_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2120,6 +2138,11 @@
                    'ns3::Ipv6Address', 
                    [param('ns3::Address', 'addr'), param('ns3::Ipv6Address', 'prefix')], 
                    is_static=True)
+    ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Address addr, ns3::Ipv6Prefix prefix) [member function]
+    cls.add_method('MakeAutoconfiguredAddress', 
+                   'ns3::Ipv6Address', 
+                   [param('ns3::Address', 'addr'), param('ns3::Ipv6Prefix', 'prefix')], 
+                   is_static=True)
     ## ipv6-address.h (module 'network'): static ns3::Ipv6Address ns3::Ipv6Address::MakeAutoconfiguredAddress(ns3::Mac16Address addr, ns3::Ipv6Address prefix) [member function]
     cls.add_method('MakeAutoconfiguredAddress', 
                    'ns3::Ipv6Address', 
@@ -2195,6 +2218,18 @@
                    [param('uint8_t *', 'address')])
     return
 
+def register_Ns3Ipv6AddressHash_methods(root_module, cls):
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash() [constructor]
+    cls.add_constructor([])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6AddressHash::Ipv6AddressHash(ns3::Ipv6AddressHash const & arg0) [constructor]
+    cls.add_constructor([param('ns3::Ipv6AddressHash const &', 'arg0')])
+    ## ipv6-address.h (module 'network'): size_t ns3::Ipv6AddressHash::operator()(ns3::Ipv6Address const & x) const [member operator]
+    cls.add_method('operator()', 
+                   'size_t', 
+                   [param('ns3::Ipv6Address const &', 'x')], 
+                   custom_name='__call__', is_const=True)
+    return
+
 def register_Ns3Ipv6Prefix_methods(root_module, cls):
     cls.add_output_stream_operator()
     cls.add_binary_comparison_operator('==')
@@ -2215,6 +2250,11 @@
     cls.add_constructor([param('ns3::Ipv6Prefix const &', 'prefix')])
     ## ipv6-address.h (module 'network'): ns3::Ipv6Prefix::Ipv6Prefix(ns3::Ipv6Prefix const * prefix) [constructor]
     cls.add_constructor([param('ns3::Ipv6Prefix const *', 'prefix')])
+    ## ipv6-address.h (module 'network'): ns3::Ipv6Address ns3::Ipv6Prefix::ConvertToIpv6Address() const [member function]
+    cls.add_method('ConvertToIpv6Address', 
+                   'ns3::Ipv6Address', 
+                   [], 
+                   is_const=True)
     ## ipv6-address.h (module 'network'): void ns3::Ipv6Prefix::GetBytes(uint8_t * buf) const [member function]
     cls.add_method('GetBytes', 
                    'void', 
@@ -2623,8 +2663,8 @@
 def register_Ns3OlsrHelper_methods(root_module, cls):
     ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper::OlsrHelper() [constructor]
     cls.add_constructor([])
-    ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper::OlsrHelper(ns3::OlsrHelper const & arg0) [constructor]
-    cls.add_constructor([param('ns3::OlsrHelper const &', 'arg0')])
+    ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper::OlsrHelper(ns3::OlsrHelper const & o) [constructor]
+    cls.add_constructor([param('ns3::OlsrHelper const &', 'o')])
     ## olsr-helper.h (module 'olsr'): ns3::OlsrHelper * ns3::OlsrHelper::Copy() const [member function]
     cls.add_method('Copy', 
                    'ns3::OlsrHelper *', 
@@ -4426,10 +4466,10 @@
     cls.add_method('SetPriority', 
                    'void', 
                    [param('uint8_t', 'priority')])
-    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> arg0) [member function]
+    ## socket.h (module 'network'): void ns3::Socket::SetRecvCallback(ns3::Callback<void, ns3::Ptr<ns3::Socket>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> receivedData) [member function]
     cls.add_method('SetRecvCallback', 
                    'void', 
-                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'arg0')])
+                   [param('ns3::Callback< void, ns3::Ptr< ns3::Socket >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'receivedData')])
     ## socket.h (module 'network'): void ns3::Socket::SetRecvPktInfo(bool flag) [member function]
     cls.add_method('SetRecvPktInfo', 
                    'void', 
@@ -8158,7 +8198,7 @@
     cls.add_method('GetIpv4', 
                    'ns3::Ptr< ns3::Ipv4 >', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   deprecated=True, is_const=True, is_virtual=True)
     ## olsr-routing-protocol.h (module 'olsr'): void ns3::olsr::RoutingProtocol::PrintRoutingTable(ns3::Ptr<ns3::OutputStreamWrapper> stream, ns3::Time::Unit unit=::ns3::Time::Unit::S) const [member function]
     cls.add_method('PrintRoutingTable', 
                    'void', 
